{-| A general purpose library for simulating differential processes, of a deterministic or
    stochastic nature. -}

module Goal.Simulation
    ( -- * Exports
      module Goal.Simulation.Mealy
    , module Goal.Simulation.Flow
    , module Goal.Simulation.Filter
    , module Goal.Simulation.Filter.Flow
    , module Goal.Simulation.Optimization
    , module Goal.Simulation.Chain
    , module Goal.Simulation.Plot
    , module Goal.Simulation.Physics.Configuration
    , module Goal.Simulation.Physics.Models.Pendulum
    ) where

--- Imports ---


-- Goal --

import Goal.Simulation.Mealy
import Goal.Simulation.Optimization
import Goal.Simulation.Flow
import Goal.Simulation.Filter
import Goal.Simulation.Filter.Flow
import Goal.Simulation.Chain
import Goal.Simulation.Plot
import Goal.Simulation.Physics.Configuration
import Goal.Simulation.Physics.Models.Pendulum
